// $Id: test.cpp,v 1.1 2008/06/22 22:27:39 fazekas Exp $

//////////////////////////////////////////////////////////////////////////

#include "unwarp.h"
#include <iostream>
#include <cv.h>

//////////////////////////////////////////////////////////////////////////

int main(int argc, char * argv[])
{
  int const w = 4, h = 3;

  short int a[w*h] =
  {
    1, 2, 3, 4,
    5, 6, 7, 8,
    9, 10, 11, 12,
  };

  short int b[w*h] =
  {
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
  };

  int const n = 7;
  float const d[][2] =
  {
    {0, 0},
    {1.4, 0},
    {1.5, 0},
    {1.6, 0},
    {-1.6, 0},
    {-1.5, 0},
    {-1.4, 0},
  };

  CvMat Ma, Mb;

  cvInitMatHeader(&Ma, h, w, CV_16UC1, a);
  cvInitMatHeader(&Mb, h, w, CV_16UC1, b);

  for(int k = 0; k < n; ++k)
  {
    float u[w*h] =
    {
      d[k][0], d[k][0], d[k][0], d[k][0],
      d[k][0], d[k][0], d[k][0], d[k][0],
      d[k][0], d[k][0], d[k][0], d[k][0],
    };

    float v[w*h] =
    {
      d[k][1], d[k][1], d[k][1], d[k][1],
      d[k][1], d[k][1], d[k][1], d[k][1],
      d[k][1], d[k][1], d[k][1], d[k][1],
    };

    CvMat Mu, Mv;

    cvInitMatHeader(&Mu, h, w, CV_32FC1, u);
    cvInitMatHeader(&Mv, h, w, CV_32FC1, v);

    cvExUnwarp(&Ma, &Mb, &Mu, &Mv);

    std::cout
      << "------------------------"
      << std::endl;
    std::cout
      << d[k][0] << ' ' << d[k][1]
      << std::endl;
    std::cout
      << "------------------------"
      << std::endl;
    for(int y = 0; y < h; ++y)
    {
      for(int x = 0; x < w; ++x)
      {
        int const xy = y * w + x;
        std::cout << b[xy] << ' ';
      }
      std::cout << std::endl;
    }
  }

  return EXIT_SUCCESS;
}

//////////////////////////////////////////////////////////////////////////

// End of File
